/* $Id: main.c 12 2023-02-22 14:16:46Z nishi $ */

#include <ncron/util.h>
#include <ncron.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

char** argv;
int argc;
char soutlog;

void ncron_version(){
	printf("ncron %s\n", NCRON_VERSION);
	exit(0);
}

int main(int argc_, char** argv_){
	argc = argc_;
	argv = argv_;
	int i;
	char nodaemon = 0;
	soutlog = 0;
	for(i = 1; argv[i] != NULL; i++){
		if(argv[i][0] == '-'){
			enum {
				SUCCESS = 0,
				CHARFAIL,
				LONGFAIL
			} ERR;
			char unknown_option = SUCCESS;
			char unknown_char;
			char* unknown_long;
			if(argv[i][1] != '-'){
				int j;
				for(j = 1; argv[i][j] != 0; j++){
					char opt = argv[i][j];
					if(opt == 'v'){
						ncron_version();
						break;
					}else if(opt == 'D'){
						nodaemon = 1;
					}else if(opt == 'd'){
						nodaemon = 0;
					}else if(opt == 's'){
						soutlog = 1;
					}else{
						unknown_option = CHARFAIL;
						unknown_char = opt;
						break;
					}
				}
			}else{
				if(strcmp(argv[i], "--version") == 0){
					ncron_version();
					break;
				}else if(strcmp(argv[i], "--nodaemon") == 0){
					nodaemon = 1;
				}else if(strcmp(argv[i], "--daemon") == 0){
					nodaemon = 0;
				}else if(strcmp(argv[i], "--stdout-log") == 0){
					soutlog = 1;
				}else{
					unknown_option = LONGFAIL;
					unknown_long = argv[i];
					break;
				}
			}
			if(unknown_option != SUCCESS){
				if(unknown_option == LONGFAIL){
					fprintf(stderr, "%s: unknown option `%s`\n", argv[0], unknown_long);
				}else{
					fprintf(stderr, "%s: unknown option `%c`\n", argv[0], unknown_char);
				}
				return 1;
			}
		}
	}
	if(!(getuid() == geteuid() && getuid() == 0)){
		fprintf(stderr, "%s: only root can start ncron\n", argv[0]);
		return 1;
	}
	pid_t pid = 0;
	if(nodaemon == 0){
		pid = fork();
	}
	if(pid == 0){
		ncron_start();
	}
	return 0;
}
